src/accounts/models.py
from werkzeug.security import generate_password_hash, check_password_hash
from flask_login import UserMixin
from src import db


class User(UserMixin, db.Model):
    id = db.Column(db.Integer, primary_key=True)
    username = db.Column(db.String(64), unique=True, nullable=False)
    email = db.Column(db.String(120), unique=True, nullable=False)
    password_hash = db.Column(db.String(512))
    books = db.relationship('Book', backref='user', lazy='dynamic')

    def set_password(self, password):
        self.password_hash = generate_password_hash(
            password, method='pbkdf2:sha256', salt_length=8)

    def check_password(self, password):
        return check_password_hash(self.password_hash, password)

src/core/models.py
from datetime import datetime
from src import db


class Book(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    user_id = db.Column(db.Integer, db.ForeignKey('user.id'))
    title = db.Column(db.String(100), nullable=False)
    image = db.Column(db.LargeBinary)
    image_filename = db.Column(db.String(100))
    author = db.Column(db.String(100), nullable=False)
    description = db.Column(db.Text, nullable=False)
    published_date = db.Column(
        db.DateTime, nullable=False, default=datetime.utcnow)

    def __repr__(self):
        return f"Book('{self.title}', '{self.author}', '{self.published_date}')"

src/accounts/forms.py
from flask_wtf import FlaskForm
from wtforms import BooleanField, StringField, PasswordField, SubmitField
from wtforms.validators import DataRequired, Email, EqualTo


class RegistrationForm(FlaskForm):
    username = StringField('Username', validators=[DataRequired()])
    email = StringField('Email', validators=[DataRequired(), Email()])
    password = PasswordField('Password', validators=[DataRequired()])
    password2 = PasswordField('Repeat Password', validators=[
                              DataRequired(), EqualTo('password')])
    submit = SubmitField('Register')


class LoginForm(FlaskForm):
    username = StringField('Username', validators=[DataRequired()])
    email = StringField('Email', validators=[DataRequired(), Email()])
    password = PasswordField('Password', validators=[DataRequired()])
    remember_me = BooleanField('Remember Me')
    submit = SubmitField('Sign In')

src/core/forms.py
from flask_wtf import FlaskForm
from wtforms import DateField, StringField, TextAreaField, SubmitField
from wtforms.validators import DataRequired
from flask_wtf.file import FileField, FileAllowed


class BookForm(FlaskForm):
    title = StringField('Title', validators=[DataRequired()])
    author = StringField('Author', validators=[DataRequired()])
    image = FileField('Image', validators=[FileAllowed(['jpg', 'png'])])
    description = TextAreaField('Description', validators=[DataRequired()])
    published_date = DateField(
        'Published Date', format='%Y-%m-%d', validators=[DataRequired()])
    submit = SubmitField('Create')

src/__init__.py
from flask import Flask
from flask_sqlalchemy import SQLAlchemy
from flask_login import LoginManager
from flask_migrate import Migrate

db = SQLAlchemy()
login_manager = LoginManager()
migrate = Migrate()


def create_app():
    app = Flask(__name__, static_folder='static', template_folder='templates')
    app.secret_key = 'kakashi'
    app.config['SQLALCHEMY_DATABASE_URI'] = 'mysql+mysqlconnector://root:purplesql@localhost/books'

    db.init_app(app)
    login_manager.init_app(app)
    migrate.init_app(app, db)

    from src.accounts.views import accounts_bp
    from src.core.views import core_bp

    app.register_blueprint(accounts_bp)
    app.register_blueprint(core_bp)

    @login_manager.user_loader
    def load_user(user_id):
        from src.accounts.models import User
        return User.query.get(int(user_id))

    return app

src/accounts/views.py
from flask import render_template, flash, redirect, url_for, Blueprint, request
from flask_login import login_user, logout_user, current_user, login_required
from src import db
from src.accounts.forms import RegistrationForm, LoginForm
from src.accounts.models import User

accounts_bp = Blueprint('accounts', __name__)


@accounts_bp.route('/register', methods=['GET', 'POST'])
def register():
    if current_user.is_authenticated:
        return redirect(url_for('core.index'))
    form = RegistrationForm()
    if form.validate_on_submit():
        existing_user = User.query.filter((User.username == form.username.data) | (
            User.email == form.email.data)).first()
        if existing_user:
            flash(
                'A user with this username or email already exists. Please register with different credentials.')
            return redirect(url_for('accounts.register'))
        user = User(username=form.username.data, email=form.email.data)
        user.set_password(form.password.data)
        db.session.add(user)
        db.session.commit()
        flash('Congratulations, you are now a registered user!')
        return redirect(url_for('accounts.login'))
    return render_template('accounts/register.html', title='Register', form=form)


@accounts_bp.route('/login', methods=['GET', 'POST'])
def login():
    if current_user.is_authenticated:
        return redirect(url_for('core.index'))
    form = LoginForm()
    if form.validate_on_submit():
        user = User.query.filter_by(
            username=form.username.data, email=form.email.data).first()
        if user is None:
            flash('Username/Email does not exist. Please register first.', 'error')
            return redirect(url_for('accounts.login'))
        elif not user.check_password(form.password.data):
            flash('Invalid password. Please try again.', 'error')
            return redirect(url_for('accounts.login'))
        login_user(user, remember=form.remember_me.data)
        flash('You have been logged in successfully!', 'success')
        return redirect(url_for('core.index'))
    elif request.method == 'POST':
        flash('Please correct the errors below.', 'error')
    return render_template('accounts/login.html', title='Sign In', form=form)


@accounts_bp.route('/logout', methods=['GET', 'POST'])
def logout():
    logout_user()
    return redirect(url_for('core.dashboard'))


@accounts_bp.route('/profile')
@login_required
def profile():
    return render_template('accounts/profile.html')

src/core/views.py
from io import BytesIO
from flask import render_template, Blueprint, redirect, url_for, flash, abort, request
from flask_login import current_user, login_required
from PIL import Image
import base64

from src import db
from src.core.forms import BookForm
from src.core.models import Book
from src.utils import save_image


core_bp = Blueprint('core', __name__)


@core_bp.route('/')
def home():
    if current_user.is_authenticated:
        return redirect(url_for('core.index'))
    return redirect(url_for('core.dashboard'))


@core_bp.route('/index')
def index():
    books = Book.query.all()
    print(books)
    books_data = []
    for book in books:
        image_data = base64.b64encode(book.image).decode('ascii')
        books_data.append({'book': book, 'image_data': image_data})
    return render_template('core/index.html', books_data=books_data)


@core_bp.route('/dashboard')
def dashboard():
    if current_user.is_authenticated:
        return redirect(url_for('core.index'))
    return render_template('core/dashboard.html')


@core_bp.route('/create', methods=['GET', 'POST'])
@login_required
def create():
    form = BookForm()
    default_img = Image.open('src/assets/default.jpg')
    default_img.thumbnail((300, 300))
    default_image_stream = BytesIO()
    default_img.save(default_image_stream, format='JPEG')
    default_image_stream.seek(0)
    default_image = base64.b64encode(
        default_image_stream.read()).decode('ascii')
    if form.validate_on_submit():
        book = Book(title=form.title.data, author=form.author.data, description=form.description.data,
                    published_date=form.published_date.data, user_id=current_user.id)
        if form.image.data:
            img = Image.open(form.image.data)
            img.thumbnail((300, 300))
            image_stream = BytesIO()
            img.save(image_stream, format='JPEG')
            image_stream.seek(0)
            book.image = image_stream.read()
        else:
            default_image_stream.seek(0)
            book.image = default_image_stream.read()
        db.session.add(book)
        db.session.commit()
        flash('Your book has been created!', 'success')
        return redirect(url_for('core.home'))
    return render_template('core/create_book.html', title='Create Book', form=form, default_image=default_image)


@core_bp.route('/book_detail/<int:book_id>', methods=['GET'])
@login_required
def book_detail(book_id):
    book = Book.query.get_or_404(book_id)
    image_data = base64.b64encode(book.image).decode(
        'ascii') if book.image else None
    return render_template('core/book_detail.html', title='Book Detail', book_data=book, image_data=image_data)


@core_bp.route('/about')
def about():
    return render_template('core/about.html')


@core_bp.route('/delete', methods=['GET', 'POST'])
@login_required
def delete():
    books = Book.query.filter_by(user_id=current_user.id).all()
    books_data = []
    for book in books:
        image_data = base64.b64encode(book.image).decode(
            'ascii') if book.image else None
        books_data.append({'book': book, 'image': image_data})
    if request.method == 'POST':
        book_id = request.form.get('book_id')
        book = Book.query.get(book_id)
        if book:
            db.session.delete(book)
            db.session.commit()
        return redirect(url_for('core.index'))
    return render_template('core/delete_book.html', title='Delete Books', books=books_data)


@core_bp.route('/delete_book/<int:book_id>', methods=['GET', 'POST'])
@login_required
def delete_book(book_id):
    book = Book.query.get_or_404(book_id)
    image_data = base64.b64encode(book.image).decode(
        'ascii') if book.image else None
    return render_template('core/delete_book.html', title='Delete Book', book_data=book, image_data=image_data)


@core_bp.route('/edit', methods=['GET'])
@login_required
def edit():
    books = Book.query.filter_by(user_id=current_user.id).all()
    for book in books:
        book.image = base64.b64encode(book.image).decode(
            'ascii') if book.image else None
    return render_template('core/edit.html', title='Edit Books', books=books)


@core_bp.route('/edit_book/<int:book_id>', methods=['GET', 'POST'])
@login_required
def edit_book(book_id):
    book = Book.query.get_or_404(book_id)
    if book.user_id != current_user.id:
        abort(403)
    form = BookForm()
    if form.validate_on_submit():
        book.title = form.title.data
        book.author = form.author.data
        book.description = form.description.data
        book.published_date = form.published_date.data
        if form.image.data:
            img = Image.open(form.image.data)
            img.thumbnail((300, 300))
            image_stream = BytesIO()
            img.save(image_stream, format='JPEG')
            image_stream.seek(0)
            book.image = image_stream.read()
        db.session.commit()
        flash('Your book has been updated!', 'success')
        return redirect(url_for('core.index'))
    elif request.method == 'GET':
        form.title.data = book.title
        form.author.data = book.author
        form.description.data = book.description
        form.published_date.data = book.published_date
    image_data = base64.b64encode(book.image).decode('ascii')
    return render_template('core/edit_book.html', title='Edit Book', form=form, legend='Edit Book', image_data=image_data)

src/templates/core/about.html
{% extends "_base.html" %} {% block content %}
<div>
  <h1>About Us</h1>
  <p>
    Welcome to our book collection website! We are passionate about books and
    created this site to share our collection with other book lovers.
  </p>
  <p>
    On this site, you can browse our collection, learn more about each book, and
    even add your own books to the collection.
  </p>
  <p>
    We hope you enjoy using our site as much as we enjoyed creating it. Happy
    reading!
  </p>
</div>
{% endblock %}

src/templates/core/book_detail.html
{% extends "_base.html" %} {% block content %}
<div class="book-detail">
  <h1 class="book-title">{{ book_data.title }}</h1>
  <h2 class="book-author">by {{ book_data.author }}</h2>
  <p class="book-published-date">
    Published on {{ book_data.published_date.strftime('%Y-%m-%d') }}
  </p>

  <div class="book-image">
    {% if image_data %}
    <img src="data:image/jpeg;base64,{{ image_data|safe }}" alt="Book image" />
    {% endif %}
  </div>

  <div class="book-description">
    <h3>Description</h3>
    <p>{{ book_data.description }}</p>
  </div>
</div>
{% endblock %}

src/templates/core/create_book.html
<!-- create_book.html -->

{% extends "_base.html" %} {% block content %}
<div class="create">
  <form method="POST" enctype="multipart/form-data">
    {{ form.hidden_tag() }}

    <label for="title">Title:</label>
    {{ form.title(id='title') }}

    <label for="author">Author:</label>
    {{ form.author(id='author') }}

    <label for="description">Description:</label>
    {{ form.description(id='description') }}

    <label for="published_date">Published Date:</label>
    {{ form.published_date(id='published_date', type='date') }}

    <label for="image">Image:</label>
    {{ form.image(id='image', onchange="loadFile(event)") }}

    <img
      id="output"
      src="data:image/jpeg;base64,{{ default_image|safe }}"
      style="max-width: 300px"
      class="create--image"
    />

    <input type="submit" value="Create Book" class="create--submit" />
  </form>
</div>
<script src="{{ url_for('static', filename='js/imagePreview.js') }}"></script>

{% endblock %}

src/templates/core/dashboard.html
<!-- dashboard.html -->

{% extends "_base.html" %} {% block content %}
<div class="dashboard">
  <h1 class="dashboard_title">Welcome to the Dashboard!</h1>
  <div class="dashboard--content">
    <a href="{{ url_for('accounts.login') }}">Login</a>
    <a href="{{ url_for('accounts.register') }}">Register</a>
  </div>
</div>

{% endblock %}

src/templates/core/delete_book.html
{% extends "_base.html" %} {% block content %} {% for item in books %}
<div class="delete">
  <div class="book-card">
    <h3>{{ item.book.title }}</h3>
    <p>by {{ item.book.author }}</p>
    <p>Published on {{ item.book.published_date.strftime('%Y-%m-%d') }}</p>
    <p>{{ item.book.description }}</p>
    {% if item.image %}
    <img
      src="data:image/jpeg;base64,{{ item.image|safe }}"
      alt="Book image"
      style="max-width: 300px"
    />
    {% else %}
    <img
      src="{{ url_for('static', filename='assets/default.jpg') }}"
      alt="Default image"
      style="max-width: 300px"
    />
    {% endif %}
    <form method="POST">
      <input type="hidden" name="book_id" value="{{ item.book.id }}" />
      <input type="submit" value="Delete" class="delete--submit" />
    </form>
  </div>
</div>
{% endfor %} {% endblock %}

src/templates/core/edit.html
{% extends "_base.html" %} {% block content %} {% for book in books %}
<div class="edit">
  <div class="book-card">
    <h3>{{ book.title }}</h3>
    <p>by {{ book.author }}</p>
    <p>Published on {{ book.published_date.strftime('%Y-%m-%d') }}</p>
    <p>{{ book.description }}</p>
    <img src="data:image/jpeg;base64,{{ book.image|safe }}" alt="Book image" />
    <a
      href="{{ url_for('core.edit_book', book_id=book.id) }}"
      class="edit--submit"
      >Edit</a
    >
  </div>
</div>
{% endfor %} {% endblock %}

src/templates/core/edit_book.html
{% extends "_base.html" %} {% block content %}
<div class="editbook">
  <form method="POST" enctype="multipart/form-data">
    {{ form.hidden_tag() }}
    <p class="form-group">
      {{ form.title.label(class="form-label") }}<br />
      {{ form.title(class="form-control") }}<br />
      {% for error in form.title.errors %}
      <span class="form-error">[{{ error }}]</span>
      {% endfor %}
    </p>
    <p class="form-group">
      {{ form.author.label(class="form-label") }}<br />
      {{ form.author(class="form-control") }}<br />
      {% for error in form.author.errors %}
      <span class="form-error">[{{ error }}]</span>
      {% endfor %}
    </p>
    <p class="form-group">
      {{ form.description.label(class="form-label") }}<br />
      {{ form.description(class="form-control") }}<br />
      {% for error in form.description.errors %}
      <span class="form-error">[{{ error }}]</span>
      {% endfor %}
    </p>
    <p class="form-group">
      {{ form.published_date.label(class="form-label") }}<br />
      {{ form.published_date(class="form-control") }}<br />
      {% for error in form.published_date.errors %}
      <span class="form-error">[{{ error }}]</span>
      {% endfor %}
    </p>
    <p class="form-group">
      {{ form.image.label(class="form-label") }}<br />
      {{ form.image(class="form-control") }}<br />
      <img
        id="preview"
        src="data:image/jpeg;base64,{{ image_data|safe }}"
        alt="Book image"
        class="form-image"
      />
      {% for error in form.image.errors %}
      <span class="form-error">[{{ error }}]</span>
      {% endfor %}
    </p>
    <p><input type="submit" value="Update Book" class="editbook--submit" /></p>
  </form>
</div>
<script src="{{ url_for('static', filename='js/previewImage.js') }}"></script>
{% endblock %}

src/templates/core/index.html
{% extends "_base.html" %} {% block content %} {% for book_data in books_data %}
<div class="index">
  <div class="book-card">
    <h3>{{ book_data.book.title }}</h3>
    <p>by {{ book_data.book.author }}</p>
    <p>Published on {{ book_data.book.published_date.strftime('%Y-%m-%d') }}</p>
    <img
      src="data:image/jpeg;base64,{{ book_data.image_data|safe }}"
      alt="Book image"
    />
    <p>{{ book_data.book.description }}</p>
  </div>
</div>
{% endfor %} {% endblock %}